import { createContext, Component, createElement, useContext } from 'react';

const context = createContext({});

function boundary(component) {
    var _a;
    return _a = class Boundary extends Component {
            constructor() {
                super(...arguments);
                this.state = {};
            }
            componentDidCatch(error, errorInfo) {
                this.setState({
                    error,
                    errorInfo
                });
            }
            render() {
                return createElement(context.Provider, {
                    value: this.state,
                    children: createElement(component, this.props)
                });
            }
        },
        _a.displayName = `Boundary(${component.displayName || component.name || 'Component'})`,
        _a;
}

function useError() {
    const { error, errorInfo } = useContext(context);
    return [error, errorInfo];
}

export { boundary, useError };
//# sourceMappingURL=index.es.js.map
