'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var react = require('react');

const context = react.createContext({});

function boundary(component) {
    var _a;
    return _a = class Boundary extends react.Component {
            constructor() {
                super(...arguments);
                this.state = {};
            }
            componentDidCatch(error, errorInfo) {
                this.setState({
                    error,
                    errorInfo
                });
            }
            render() {
                return react.createElement(context.Provider, {
                    value: this.state,
                    children: react.createElement(component, this.props)
                });
            }
        },
        _a.displayName = `Boundary(${component.displayName || component.name || 'Component'})`,
        _a;
}

function useError() {
    const { error, errorInfo } = react.useContext(context);
    return [error, errorInfo];
}

exports.boundary = boundary;
exports.useError = useError;
//# sourceMappingURL=index.js.map
